!function(e){if("object"==typeof exports)module.exports=e();else if("function"==typeof define&&define.amd)define(e);else{var f;"undefined"!=typeof window?f=window:"undefined"!=typeof global?f=global:"undefined"!=typeof self&&(f=self),f.miniprism=e()}}(function(){var define,module,exports;return (function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);throw new Error("Cannot find module '"+o+"'")}var f=n[o]={exports:{}};t[o][0].call(f.exports,function(e){var n=t[o][1][e];return s(n?n:e)},f,f.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(_dereq_,module,exports){
"use strict";

/*
 * The syntax parsing algorithm in this file is copied heavily from Lea Verou's
 * Prism project, which bears this license:
 *
 * MIT LICENSE
 *
 * Copyright (c) 2012-2013 Lea Verou
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
*/

var grammars = _dereq_("./grammars");
exports.grammars = grammars;

exports.highlight = function highlight(source, grammarName) {
  var opts = arguments[2] === undefined ? {} : arguments[2];
  var grammar = undefined;

  if (typeof grammarName === "string") {
    grammar = grammars[grammarName];
  }

  if (typeof grammarName === "object" && grammarName.constructor === Object) {
    grammar = grammarName;
  }

  if (!grammar) {
    throw new Error("Grammar \"" + grammarName + "\" not found.");
  }

  return stringify(encode(tokenize(source, grammar)), opts.lineClass);
};

function tokenize(source, grammar) {
  var strings = [source];
  var inlines = grammar.inlines;

  if (inlines) {
    // jshint -W089
    for (var inlineToken in inlines) {
      grammar[inlineToken] = inlines[inlineToken];
    }

    delete grammar.inlines;
  }

  for (var token in grammar) {
    var patterns = grammar[token];

    if (!Array.isArray(patterns)) {
      patterns = [patterns];
    }

    for (var i = 0; i < patterns.length; i++) {
      var pattern = patterns[i];
      var block = pattern.block;
      var classes = pattern.classes;
      var inside = pattern.inside;
      var lookbehind = !!pattern.lookbehind;
      var lookbehindLength = 0;
      var tag = undefined;

      if (pattern.tag) {
        tag = pattern.tag;
      } else {
        tag = block ? "div" : "span";
      }

      pattern = pattern.pattern || pattern;

      for (var _i = 0; _i < strings.length; _i++) {
        var string = strings[_i];

        if (typeof string !== "string") {
          continue;
        }

        pattern.lastIndex = 0;

        var match = pattern.exec(string);

        if (!match) {
          continue;
        }

        if (lookbehind) {
          lookbehindLength = match[1].length;
        }

        var from = match.index - 1 + lookbehindLength;
        match = match[0].slice(lookbehindLength);
        var len = match.length;
        var to = from + len;
        var before = string.slice(0, from + 1);
        var after = string.slice(to + 1);
        var args = [_i, 1];

        if (before) {
          args.push(before);
        }

        var wrapped = {
          block: block,
          classes: classes,
          tag: tag,
          text: inside ? tokenize(match, inside) : match,
          token: token
        };

        args.push(wrapped);

        if (after) {
          args.push(after);
        }

        Array.prototype.splice.apply(strings, args);
      }
    }
  }

  return strings;
}

function stringify(source) {
  var lineClass = arguments[1] === undefined ? "md-line" : arguments[1];
  if (source === "\n") {
    return "<br>";
  }

  if (typeof source === "string") {
    return source.replace(/\n/g, "");
  }

  if (Array.isArray(source)) {
    return source.reduce(function addItem(result, item) {
      return result + stringify(item, lineClass);
    }, "");
  }

  var tag = source.tag;
  var classList = source.classes || source.token.split(" ");
  var className = classList.map(function (token) {
    return "md-" + token;
  }).join(" ");

  if (source.block) {
    className += " " + lineClass;
  }

  return ["<" + tag + " class=\"" + className + "\">", stringify(source.text, lineClass), "</" + tag + ">"].join("");
}

function encode(src) {
  if (Array.isArray(src)) {
    return src.map(encode);
  } else if (typeof src === "object") {
    src.text = encode(src.text);
    return src;
  } else {
    return escapeHTML(src);
  }
}

function escapeHTML(str) {
  return str.replace(/&/g, "&amp;").replace(/>/g, "&gt;").replace(/</g, "&lt;").replace(/"/g, "&quot;").replace(/'/g, "&#x27;").replace(/\//g, "&#x2F;");
}

},{"./grammars":2}],2:[function(_dereq_,module,exports){
"use strict";

exports.markdown = _dereq_("./markdown");

},{"./markdown":3}],3:[function(_dereq_,module,exports){
"use strict";

/*
 * These regexes are in some places copies of, in others modifications of, and
 * in some places wholly unrelated to the Markdown regexes found in the
 * Stackedit project, which bears this license:
 *
 * StackEdit - The Markdown editor powered by PageDown.

 * Copyright 2013 Benoit Schweblin (http://www.benoitschweblin.com)
 * Licensed under an Apache License (http://www.apache.org/licenses/LICENSE-2.0)
 */

exports.gfm = {
  block: true,
  pattern: /^`{3}.*\n(?:[\s\S]*?)\n`{3} *(?:\n|$)/gm,
  inside: {
    "gfm-limit": {
      block: true,
      pattern: /^`{3}.*(?:\n|$)/gm,
      inside: {
        "gfm-info": {
          lookbehind: true,
          pattern: /^(`{3}).+(?:\n|$)/
        },
        "gfm-fence": /^`{3}(?:\n|$)/gm
      }
    },
    "gfm-line": {
      block: true,
      pattern: /^.*(?:\n|$)/gm
    } }
};

exports.blank = [{
  block: true,
  pattern: /\n(?![\s\S])/mg
}, {
  block: true,
  pattern: /^\n/mg
}];

exports["setex-h1"] = {
  block: true,
  pattern: /^.+\n=+[ \t]*(?:\n|$)/gm,
  inside: {
    "setex-header": {
      block: true,
      pattern: /^[^=].*(?:\n|$)/gm
    },
    "setex-marker": {
      block: true,
      pattern: /^=+[ \t]*(?:\n|$)/
    }
  }
};

exports["setex-h2"] = {
  block: true,
  pattern: /^(?!^- ).+\n-+[ \t]*(?:\n|$)/gm,
  inside: {
    "setex-header": {
      block: true,
      pattern: /^[^-].*(?:\n|$)/gm
    },
    "setex-marker": {
      block: true,
      pattern: /^-+[ \t]*(?:\n|$)/
    }
  }
};

exports.code = {
  block: true,
  pattern: /^(?: {4,}|\t).+(?:\n|$)/gm
};

// h1 through h6
for (var i = 1; i < 7; i++) {
  exports["h" + i] = {
    classes: ["h" + i, "has-folding"],
    block: true,
    pattern: new RegExp("^#{" + i + "} .*(?:\n|$)", "gm"),
    inside: {
      "hash folding": new RegExp("^#{" + i + "} ")
    }
  };
}

exports.ul = {
  classes: ["ul", "has-folding"],
  block: true,
  pattern: /^[ \t]*(?:[*+\-])[ \t].*(?:\n|$)/gm,
  inside: {
    "ul-marker folding": /^[ \t]*(?:[*+\-])[ \t]/
  }
};

exports.ol = {
  block: true,
  pattern: /^[ \t]*(?:\d+)\.[ \t].*(?:\n|$)/gm,
  inside: {
    "ol-marker": /^[ \t]*(?:\d+)\.[ \t]/
  }
};

exports.blockquote = {
  block: true,
  pattern: /^ {0,3}> *.*(?:\n|$)/gm,
  inside: {
    "blockquote-marker": /^ {0,3}> */
  }
};

exports.hr = {
  block: true,
  pattern: /^(?:[*\-_] *){3,}(?:\n|$)/gm
};

exports["link-def"] = {
  block: true,
  pattern: /^ {0,3}\[.*?\]:[ \t]+.+(?:\n|$)/gm,
  inside: {
    "link-def-name": {
      pattern: /^ {0,3}\[.*?\]:/,
      inside: {
        "bracket-start": /^\[/,
        "bracket-end": /\](?=:$)/,
        colon: /:$/
      }
    },

    "link-def-value": /.*(?:\n|$)/
  }
};

exports.p = {
  block: true,
  pattern: /^.+(?:\n|$)/gm,
  inside: {}
};

// jshint -W101
exports.link = {
  classes: ["link", "has-folding"],
  pattern: /\[(?:(?:\\.)|[^\[\]])*\]\([^\(\)\s]+(?:\(\S*?\))??[^\(\)\s]*?(?:\s(?:['‘][^'’]*['’]|["“][^"”]*["”]))?\)/gm,
  inside: {
    "bracket-start folding": {
      pattern: /(^|[^\\])\[/,
      lookbehind: true
    },

    ref: /(?:(?:\\.)|[^\[\]])+(?=\])/,

    "bracket-end folding": /\](?=\s?\()/,
    "paren-start folding": /^\(/,
    "paren-end folding": /\)$/,
    "href folding": /.*/
  }
};

// jshint +W101
exports["link-ref"] = {
  classes: ["link-ref", "has-folding"],
  pattern: /\[(?:.*?)\] ?\[(?:.*?)\]/g,
  inside: {
    "ref-value folding": {
      pattern: /\[[^\[\]]+\]$/,
      inside: {
        "bracket-start": /\[/,
        "ref-href": /[^\[\]]+(?=]$)/,
        "bracket-end": /\]/
      }
    },

    "ref-text": {
      pattern: /^\[[^\[\]]+\]/,
      inside: {
        "bracket-start folding": /^\[/,
        ref: /^[^\[\]]+/,
        "bracket-end folding": /\]$/
      }
    }
  }
};

exports.em = {
  classes: ["em", "has-folding"],
  pattern: /(^|[^\\])(\*|_)(\S[^\2]*?)??[^\s\\]+?\2/g,
  lookbehind: true,
  inside: {
    "em-marker folding": /(?:^(?:\*|_))|(?:(?:\*|_)$)/
  }
};

exports.strong = {
  classes: ["strong", "has-folding"],
  pattern: /([_\*]){2}(?:(?!\1{2}).)*\1{2}/g,
  inside: {
    "strong-marker folding": /(?:^(?:\*|_){2})|(?:(?:\*|_){2}$)/
  }
};

exports["inline-code"] = {
  classes: ["inline-code", "has-folding"],
  pattern: /(?:^|[^\\])(`+)(?:\S.*)??[^\s`]\1/g,
  lookbehind: true,
  inside: {
    "inline-code-marker folding": /(?:^(?:`))|(?:(?:`)$)/
  }
};

var inlines = {
  strong: exports.strong,
  em: exports.em,
  link: exports.link,
  "inline-code": exports["inline-code"],
  "link-ref": exports["link-ref"]
};

["setex-h1", "setex-h2", "h1", "h2", "h3", "h4", "h5", "h6", "ul", "ol", "blockquote", "p"].forEach(function (token) {
  exports[token].inside.inlines = inlines;
});

["em", "strong"].forEach(function (token) {
  exports[token].inside = exports[token].inside || {};
  exports[token].inside.inlines = {
    link: exports.link,
    "link-ref": exports["link-ref"]
  };
});

},{}]},{},[1])
(1)
});